#!/usr/bin/env python3
	
import sys
from Crypto.Util.number import *
from flag import flag
	
def die(*args):
	pr(*args)
	quit()
	
def pr(*args):
	s = " ".join(map(str, args))
	sys.stdout.write(s + "\n")
	sys.stdout.flush()
	
def sc(): 
	return sys.stdin.buffer.readline()

def keygen(r):
	assert len(r) <= 60
	v, l = int(r, 16), len(r)
	e = (64 - l) << 4
	u, w = v << e, 2 ** (e >> 1)
	for _ in range(110):
		r = getRandomRange(1, w)
		p = r + u
		while p >> e == v:
			if isPrime(p):
				while True:
					x, y = [2 * getRandomNBitInteger(p.bit_length() >> 2) for _ in '__']
					P, Q = x * p | 1, y * p | 1
					if isPrime(P) and isPrime(Q):
						return P, Q
			p += 1

def main():
	border = "|"
	pr(border*72)
	pr(border, f"Welcome to Blex task! Your mission is break our complex cryptosystem", border)
	pr(border*72)
	pr(border, f"please provide your desired seed to generate key in hex:")
	seed = sc().decode()
	try:
		_b = len(seed) <= 60 and int(seed, 16) >= 0
	except:
		die(border, f"The seed you provided is either not in hex or is not valid!")
	if _b:
		pr(border, f"Generating keypair, please wait...")
		p, q = keygen(seed)
		e, n =  65537, p * q
		m = bytes_to_long(flag)
		assert m < n
		c = pow(m, e, n)
		pr(border, f'n = {n}')
		pr(border, f'c = {c}')
	else:
		die(border, f"Your seed is too long!!!")

if __name__ == '__main__':
	main()